import { defineComponent as $, computed as S, ref as A, onMounted as N, openBlock as m, createElementBlock as h, normalizeClass as C, unref as l, withDirectives as z, createElementVNode as n, mergeProps as E, vModelCheckbox as P, renderSlot as s, createTextVNode as y, toDisplayString as d, normalizeProps as f, guardReactiveProps as p, createBlock as w, withCtx as B, createCommentVNode as V, createVNode as D } from "vue";
import { useFormControl as M, FormControlErrors as G, FormControlFeedback as R } from "@vue-interface/form-control";
const U = ["value"], j = ["for"], q = {
  invalid: "",
  class: "invalid-feedback"
}, H = /* @__PURE__ */ n("br", null, null, -1), I = {
  valid: "",
  class: "valid-feedback"
}, L = /* @__PURE__ */ $({
  inheritAttrs: !1,
  __name: "CheckboxField",
  props: {
    activity: { type: Boolean },
    disabled: { type: Boolean },
    error: {},
    errors: {},
    feedback: {},
    formControlClass: { default: "form-check" },
    helpText: {},
    id: {},
    indicator: {},
    indicatorSize: {},
    invalid: { type: Boolean },
    label: {},
    labelClass: { default: "form-check-label" },
    modelValue: {},
    name: {},
    plaintext: { type: Boolean },
    readonly: { type: Boolean },
    valid: { type: Boolean },
    value: {},
    checked: { type: Boolean }
  },
  emits: ["blur", "change", "click", "focus", "update:modelValue"],
  setup(g, { emit: F }) {
    const i = F, a = g, t = S({
      get: () => a.modelValue,
      set: (e) => i("update:modelValue", e)
    }), {
      controlAttributes: k,
      formGroupClasses: T,
      onClick: c,
      onBlur: b,
      onFocus: v
    } = M({ props: a, emit: i, model: t }), u = A();
    return N(() => {
      a.checked && ((Array.isArray(a.modelValue) && !a.modelValue.includes(a.value) || !a.modelValue) && u.value.click(), u.value.checked = !0);
    }), (e, r) => (m(), h("div", {
      class: C(["checkbox-field", l(T)])
    }, [
      z(n("input", E({
        ref_key: "field",
        ref: u,
        "onUpdate:modelValue": r[0] || (r[0] = (o) => t.value = o)
      }, l(k), {
        type: "checkbox",
        value: e.value,
        onChange: r[1] || (r[1] = (o) => i("change", t.value)),
        onClick: r[2] || (r[2] = //@ts-ignore
        (...o) => l(c) && l(c)(...o)),
        onBlur: r[3] || (r[3] = //@ts-ignore
        (...o) => l(b) && l(b)(...o)),
        onFocus: r[4] || (r[4] = //@ts-ignore
        (...o) => l(v) && l(v)(...o))
      }), null, 16, U), [
        [P, t.value]
      ]),
      s(e.$slots, "label", {}, () => [
        n("label", {
          ref: "label",
          class: C(e.labelClass),
          for: l(k).id
        }, [
          s(e.$slots, "default", {}, () => [
            y(d(e.label), 1)
          ])
        ], 10, j)
      ]),
      s(e.$slots, "errors", f(p({ error: e.error, errors: e.errors, id: e.id, name: e.name })), () => [
        e.error || e.errors ? (m(), w(l(G), {
          key: 0,
          id: e.id && String(e.id),
          name: e.name && String(e.name),
          error: e.error,
          errors: e.errors
        }, {
          default: B(({ error: o }) => [
            n("div", q, [
              y(d(o), 1),
              H
            ])
          ]),
          _: 1
        }, 8, ["id", "name", "error", "errors"])) : V("", !0)
      ]),
      s(e.$slots, "feedback", f(p({ feedback: e.feedback })), () => [
        D(l(R), { feedback: e.feedback }, {
          default: B(({ feedback: o }) => [
            n("div", I, d(o), 1)
          ]),
          _: 1
        }, 8, ["feedback"])
      ]),
      s(e.$slots, "help", f(p({ helpText: e.helpText })), () => [
        e.helpText ? (m(), h("small", {
          key: 0,
          ref: "help"
        }, d(e.helpText), 513)) : V("", !0)
      ])
    ], 2));
  }
});
export {
  L as CheckboxField
};
//# sourceMappingURL=checkbox-field.js.map
